// Generated by CoffeeScript 1.8.0
(function() {
  var async;

  async = require('async');

  exports.api = {
    init: function(_arg, callback) {
      var pluginFolders, preferencesFolder, version;
      pluginFolders = _arg.pluginFolders, preferencesFolder = _arg.preferencesFolder, version = _arg.version;
      if (!pluginFolders) {
        return callback(new Error("init requires pluginFolders"));
      }
      if (!preferencesFolder) {
        return callback(new Error("init requires preferencesFolder"));
      }
      LR.version = version || '0.0.0';
      return async.series([
        function(cb) {
          return LR.plugins.init(pluginFolders, cb);
        }, function(cb) {
          return LR.websockets.init(cb);
        }
      ], function(err) {
        if (err) {
          LR.client.app.failedToStart({
            message: "" + (err.stack || err.message || err)
          });
          LR.rpc.exit(1);
          return callback(null);
        }
        LR.stats.startup();
        LR.log.fyi("Backend is up and running.");
        return callback();
      });
    },
    ping: function(arg, callback) {
      return callback();
    }
  };

  exports.displayCriticalError = function(_arg) {
    var button, text, title, url;
    title = _arg.title, text = _arg.text, url = _arg.url, button = _arg.button;
    if (button == null) {
      button = "More Info";
    }
    LR.log.omg("" + title + " -- " + text);
    return LR.client.app.displayPopupMessage({
      title: title,
      text: text,
      buttons: [['help', button], ['quit', "Quit"]]
    }, function(err, result) {
      if (result === 'help') {
        LR.client.app.openUrl(url);
      }
      return LR.client.app.terminate();
    });
  };

  exports.displayHelpfulWarning = function(_arg) {
    var button, text, title, url;
    title = _arg.title, text = _arg.text, url = _arg.url, button = _arg.button;
    if (button == null) {
      button = "More Info";
    }
    LR.log.wtf("" + title + " -- " + text);
    return LR.client.app.displayPopupMessage({
      title: title,
      text: text,
      buttons: [['help', button], ['ignore', "Ignore"]]
    }, function(err, result) {
      if (result === 'help') {
        return LR.client.app.openUrl(url);
      }
    });
  };

}).call(this);
