// Generated by CoffeeScript 1.8.0
(function() {
  var CONN_CHECK, EventEmitter, PROTOCOL_7, Parser, ProtocolError,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  EventEmitter = require('events').EventEmitter;

  exports.PROTOCOL_7 = PROTOCOL_7 = 'http://livereload.com/protocols/official-7';

  exports.CONN_CHECK = CONN_CHECK = 'http://livereload.com/protocols/connection-check-1';

  exports.ProtocolError = ProtocolError = (function() {
    function ProtocolError(reason, data) {
      this.message = "LiveReload protocol error (" + reason + ") after receiving data: \"" + data + "\".";
    }

    return ProtocolError;

  })();

  exports.Parser = Parser = (function(_super) {
    __extends(Parser, _super);

    function Parser() {
      this.reset();
    }

    Parser.prototype.reset = function() {
      return this.protocols = null;
    };

    Parser.prototype.process = function(data) {
      var e, message;
      try {
        if (this.protocols == null) {
          if (data.match(/^[^\s{]/)) {
            this.emit('oldproto');
          } else if (message = this._parseMessage(data, ['hello'])) {
            if (!message.protocols.length) {
              throw new ProtocolError("no protocols specified in handshake message");
            }
            this.protocols = {};
            if (__indexOf.call(message.protocols, PROTOCOL_7) >= 0) {
              this.protocols.monitoring = 7;
            }
            if (__indexOf.call(message.protocols, CONN_CHECK) >= 0) {
              this.protocols.connCheck = 1;
            }
            if (Object.keys(this.protocols).length === 0) {
              throw new ProtocolError("no supported protocols found");
            }
            return this.emit('connected', this.protocols);
          }
        } else {
          message = this._parseMessage(data, ['info']);
          return this.emit('message', message);
        }
      } catch (_error) {
        e = _error;
        if (e instanceof ProtocolError) {
          return this.emit('error', e);
        } else {
          throw e;
        }
      }
    };

    Parser.prototype._parseMessage = function(data, validCommands) {
      var e, message, _ref;
      try {
        message = JSON.parse(data);
      } catch (_error) {
        e = _error;
        throw new ProtocolError('unparsable JSON', data);
      }
      if (!message.command) {
        throw new ProtocolError('missing "command" key', data);
      }
      if (_ref = message.command, __indexOf.call(validCommands, _ref) < 0) {
        throw new ProtocolError("invalid command '" + message.command + "', only valid commands are: " + (validCommands.join(', ')) + ")", data);
      }
      return message;
    };

    return Parser;

  })(EventEmitter);

}).call(this);
