// Generated by CoffeeScript 1.8.0
(function() {
  var Compiler, Path, Plugin, PluginManager, async, fs, loadPlugin, util;

  fs = require('fs');

  Path = require('path');

  util = require('util');

  async = require('async');

  Compiler = require('./tool').Compiler;

  Plugin = (function() {
    function Plugin(folder) {
      this.folder = folder;
    }

    Plugin.prototype.initialize = function(callback) {
      this.compilers = {};
      this.manifestFile = "" + this.folder + "/manifest.json";
      return this.parseManifest(callback);
    };

    Plugin.prototype.parseManifest = function(callback) {
      var e;
      try {
        return this.processManifest(JSON.parse(fs.readFileSync(this.manifestFile, 'utf8')), callback);
      } catch (_error) {
        e = _error;
        return callback(e);
      }
    };

    Plugin.prototype.processManifest = function(manifest, callback) {
      var compiler, compilerManifest, _i, _len, _ref;
      this.manifest = manifest;
      _ref = this.manifest.LRCompilers;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        compilerManifest = _ref[_i];
        compiler = new Compiler(this, compilerManifest);
        this.compilers[compiler.name] = compiler;
      }
      console.log("Loaded manifest at " + this.folder + " with " + this.manifest.LRCompilers.length + " compilers");
      return callback(null);
    };

    return Plugin;

  })();

  loadPlugin = function(folder, callback) {
    var plugin;
    plugin = new Plugin(folder);
    return plugin.initialize(function(err) {
      if (err) {
        return callback(err);
      }
      return callback(null, plugin);
    });
  };

  PluginManager = (function() {
    function PluginManager(folders) {
      this.folders = folders;
    }

    PluginManager.prototype.rescan = function(callback) {
      var entry, folder, pluginFolders, _i, _j, _len, _len1, _ref, _ref1;
      pluginFolders = [];
      _ref = this.folders;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        folder = _ref[_i];
        _ref1 = fs.readdirSync(folder);
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          entry = _ref1[_j];
          if (entry.endsWith('.lrplugin')) {
            pluginFolders.push(Path.join(folder, entry));
          }
        }
      }
      return async.map(pluginFolders, loadPlugin, (function(_this) {
        return function(err, result) {
          var plugin, _k, _len2, _ref2;
          if (err) {
            return callback(err);
          }
          _this.plugins = result;
          _this.compilers = {};
          _ref2 = _this.plugins;
          for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
            plugin = _ref2[_k];
            Object.merge(_this.compilers, plugin.compilers);
          }
          return callback(null);
        };
      })(this));
    };

    return PluginManager;

  })();

  exports.PluginManager = PluginManager;

  exports.Plugin = Plugin;

}).call(this);
